# Zoom Video Communications - Mobile RTC Stack and Desktop SDK LICENSE AGREEMENT

THIS ZOOM SDK LICENSE AGREEMENT (THIS "AGREEMENT") IS A LEGAL AGREEMENT BETWEEN YOU INDIVIDUALLY IF YOU ARE AGREEING TO IT IN YOUR OWN CAPACITY, OR IF YOU ARE AUTHORIZED TO ACQUIRE THE SDK ON BEHALF OF YOUR COMPANY OR ORGANIZATION, BETWEEN THE ENTITY FOR WHOSE BENEFIT YOU ACT ("YOU") AND ZOOM ("ZOOM VIDEO COMMUNICATIONS"). BEFORE DOWNLOADING THE SDK, PLEASE CAREFULLY READ THE FOLLOWING AGREEMENT. DOWNLOADING, INSTALLING, ACTIVATING OR USING THE SDK, YOU ARE AGREEING TO BE BOUND BY THE TERMS OF THIS AGREEMENT. IF YOU HAVE ANY QUESTIONS OR CONCERNS ABOUT THE TERMS OF THIS AGREEMENT, PLEASE CONTACT ZOOM AT developersupport@zoom.us. IF, PRIOR TO DOWNLOADING, INSTALLING, ACTIVATING OR USING THE SDK, YOU DECIDE YOU ARE UNWILLING TO AGREE TO THE TERMS OF THIS AGREEMENT, YOU HAVE NO RIGHT TO USE THE SDK. IN THIS CASE, DO NOT ATTEMPT TO DOWNLOAD THE SDK BY ANY MEANS AND IF YOU HAVE ALREADY DONE SO, PROMPTLY DELETE THE SDK.

## Definitions
* "API" means an application programming interface.
*	"Applications" means: (a) in the general case, software applications, or portions thereof, developed by You using the SDK for use with the Zoom Solution
*	"Authorized Users" means: (a) any of Your employees; or (b) any consultants, independent contractors and any other persons You authorize to use or to whom You otherwise make available the SDK, in each case to use on Your behalf to develop Applications
*	"Distributable Code" means Distributable Object Code and Distributable Source Code.
*	"Distributable Source Code" means certain application templates, code stubs, code snippets, example applications, sample code and code fragments in source code form either included as part of the SDK or otherwise provided to You
*	"SDK" or "Software Development Kit" means all software (including programs, tools, sample code, templates, libraries, and interfaces), Updates, APIs, information, data, files, documentation, and other materials, whether tangible or intangible, in whatever form or medium, provided to You at any time, either by way of downloading from Zoom or a Zoom affiliate website or otherwise provided to You, for any development purposes.

## License and License Restrictions
*	Subject to the terms and conditions of this Agreement: (a) Zoom hereby grants You a personal, revocable, non-exclusive, royalty free, non-transferable license to install and use a reasonable number of copies of the SDK to be used solely in the manner described in the documentation contained in the SDK and solely for the purposes of developing, testing and debugging Applications. You may not copy the SDK or any portion thereof except as expressly permitted herein. For the purposes of this provision "copy" shall not include copying of statements and instructions of the SDK or any portion thereof that naturally occurs during normal program execution when used in accordance with and for the purposes described in the documentation or in the course of making unmodified copies of the SDK or documentation as part of the regular back-up of the SDK in accordance with standard industry business practices. Notwithstanding the foregoing, if Zoom has terminated any license granted to You for any SDK, no right to use the SDK is granted to You hereunder. In such case You may contact legal@zoom.com.
*	To the extent that Distributable Source Code is provided as part of the SDK, you may use, modify and compile the Distributable Source Code solely for the purposes of developing Your Applications. Notwithstanding the foregoing, you may not modify any header files included in the SDKs.
*	You may distribute any Distributable Code provided that You shall: (i) add significant primary functionality to it in Your Applications; (ii) distribute such code in executable form only.
*	You must require users of Your Applications, in the license terms applicable to Your Applications, to agree to a prohibition on Reverse Engineering Your Applications, except to the extent that You are expressly precluded by law from imposing such restriction.

## APIs
*	You are not permitted to access or otherwise use, whether by means of Your Applications or otherwise, any APIs that are not documented by Zoom in documentation Zoom makes generally available. If changes are made to the Zoom Native SDK for iOS and Android that break compatibility with Your Applications, you should modify, recompile, and redistribute Your Applications to fix such compatibility problems.


## Use of SDK
*	You are responsible for all activities with respect to the SDK undertaken by You and Your Authorized Users and You will ensure that:
*	You and Your Authorized Users will only use the SDK in accordance with this Agreement, all applicable laws and regulations, and the documentation provided by Zoom as part of and for use in conjunction with the SDK, and Applications and any products, services or content available through Your Applications and their intended uses shall comply with all applicable laws and regulations
*	You have the right and authority to enter into this Agreement, either on Your own behalf or on behalf of a company or other entity, and You are over the age of majority
*	Any information that is provided to Zoom in relation to this Agreement is true, accurate, current and complete
*	You and Your Authorized Users will not use the SDK to develop any Applications or make any products, services or content for reselling Zoom services. Reselling Zoom services warrants an exclusive reseller agreement and written consent from Zoom
*	You and Your Authorized Users will not use the SDK to develop any Applications or make any products, services or content available through Your Applications, which are intended to be used to commit or would be used predominantly to commit any crime or other illegal or tortious acts in the jurisdiction in which You or Your distribution channels distribute that Application and without limiting the foregoing, Applications and any products, services or content available through Your Applications must not contain or link to any content, or perform any function, that is illegal (e.g. against any criminal, civil or statutory law or regulation), including, without limitation, any libel or defamation, obscenity, breach of privacy, infringement or misappropriation of any intellectual property rights and/or other proprietary rights of any party (including, without limitation, unlawfully circumventing any digital rights management protections)
*	You will not knowingly develop or distribute any Application or make available any products, services or content available through any Application that infringes any Zoom, Zoom affiliate or third party copyrights, trademarks, industrial design rights, rights of privacy and publicity, trade secrets, patents, or other proprietary or legal rights (e.g. photography or image rights, logo rights, or third party data rights)

## Intellectual Property
*	This Agreement does not transfer or assign to You, any intellectual property right including any patent, design, industrial design, trademark, servicemark, copyright or rights in any confidential information or trade secrets, in or related to the SDK or any part thereof. The SDK and all copies thereof remain the property of Zoom and are licensed and not sold to You under this Agreement. You acknowledge that there are no implied licenses granted under this Agreement, and all rights, save for those license rights expressly granted to You hereunder, shall remain with Zoom.

## Term
*	This Agreement shall be effective upon Your agreement to be bound by the terms of this Agreement and shall end upon termination of this Agreement in accordance with the provisions set out herein. Unless otherwise authorized by Zoom, You must destroy all copies and component parts of the SDK licensed under this Agreement within one (2) weeks of the termination of this Agreement, and You may be required to provide proof of such destruction to Zoom. Upon the termination of this Agreement the License shall immediately terminate and You shall promptly stop all use of the SDK.


## Termination
*	Zoom reserves the right to terminate this Agreement on thirty (30) days' notice to You for any reason whatsoever, provided that if there has been no allegation of wrongdoing on Your part or in relation to the use of Your Applications, Zoom may, at Zoom's option, provide a reasonable period for You to continue to distribute any Distributable Code that is embedded in Your Applications at the time of termination, provided You continue to do so in accordance with the terms of this Agreement as if it were still in effect.

## Exclusion of Warranties and Conditions
*	(a) ZOOM PROVIDES ALL SDKS AND ANY INFORMATION PROVIDED THROUGH ANY APIS ("API INFORMATION") "AS IS". ZOOM MAKES NO REPRESENTATIONS OR WARRANTIES, AND THERE ARE NO CONDITIONS, ENDORSEMENTS, GUARANTEES, REPRESENTATIONS OR WARRANTIES OF ANY KIND EITHER EXPRESS OR IMPLIED, (INCLUDING WITHOUT LIMITATION ANY EXPRESS OR IMPLIED WARRANTIES OR CONDITIONS OF QUALITY, PERFORMANCE, RESULTS, FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY, MERCHANTABLE QUALITY, DURABILITY, TITLE, NON-INFRINGEMENT OR ARISING BY STATUTE OR OTHERWISE IN LAW OR FROM A COURSE OF DEALING OR USAGE OF THE TRADE) ARISING OUT OF OR RELATED TO THIS AGREEMENT OR ARISING OUT OF OR RELATED TO ANY SDKS, ANY API INFORMATION OR THEIR PERFORMANCE OR FAILURE TO PERFORM

## Exclusion of Liability
*	(a) IN NO EVENT SHALL ZOOM BE LIABLE FOR ANY DAMAGES WHATSOEVER DIRECTLY OR INDIRECTLY ARISING OUT OF OR RELATED TO THIS AGREEMENT OR ANY PRODUCTS, SERVICES OR CONTENT MADE AVAILABLE THROUGH YOUR APPLICATIONS
*	(b) IN NO EVENT SHALL ANY OFFICER, DIRECTOR, EMPLOYEE, AGENT, SUPPLIER, INDEPENDENT CONTRACTOR, OR ANY MERCHANTS OF RECORD OF ZOOM OR ANY ZOOM AFFILIATE HAVE ANY LIABILITY ARISING FROM OR RELATED TO THIS AGREEMENT.

## Nature of Relationship
*	This Agreement shall not create or be construed as creating a joint venture, co-ownership, partnership, or agency relationship between You and Zoom. Neither Party will have authority to or will hold itself out as having any authority to incur, assume, or create, orally or in writing, any liability, obligation or undertaking of any kind in the name of, or on behalf of, or in any way binding upon, the other.

